from .cv import CVMS


class CaptioningMS(CVMS):
    def infer(self):
        try:
            read_response = self.runtime.describe_image_in_stream(self.image, raw=True)
            captions = read_response.response.json()["description"]["captions"]
            self.result = captions
        except Exception as e:
            self.logger.warning(f"Image Captioning Failed: {e}")
