from .cv import CVMS

class ObjectDetectionMS(CVMS):
    def infer(self):
        try:
            read_response = self.runtime.detect_objects_in_stream(self.image,raw=True)
            detection_results = read_response.response.json()['objects']
            res = []
            for box in detection_results:
                x,y,w,h=box['rectangle']['x'],box['rectangle']['y'],box['rectangle']['w'],box['rectangle']['h']
                x1,y1,x2,y2=x,y,x+w,y+h
                obj_cls = box['object']
                conf = box['confidence']
                res.append({
                    'left': x1, 'top': y1, 'right': x2, 'bottom': y2,
                    'class': obj_cls, 'confidence': conf}
                )
            self.result= res
        except Exception as e:
            self.logger.warning(f"Object Detection Failed: {e}")