from .cv import CVMS

class TaggingMS(CVMS):
    def infer(self):
        try:
            read_response = self.runtime.tag_image_in_stream(self.image,raw=True)
            tags = read_response.response.json()['tags']
            leng = max(min(0, len(tags)),10)
            self.result= tags[:leng]
        except Exception as e:
            self.logger.warning(f"Image Tagging Failed: {e}")