
######### Image sizes #########
INPUT_IMAGE_HEIGHT = 720
INPUT_IMAGE_WIDTH = 1280

HEIGHT = 192
WIDTH = 320

SHOW_HEIGHT = int(384*1.5)
SHOW_WIDTH = int(640*1.5)

IMAGE_MATCHING_HEIGHT = 192
IMAGE_MATCHING_WIDTH = 320

CLOUD_IMAGE_HEIGHT = 384
CLOUD_IMAGE_WIDTH = 640

CAMERA_RECEPTIVE_ANGLE = 150
SECONDARY_FRAME_RATE=23

######### Sensor Definitions #########
SENSOR_MAP = {
    "ax": 0,
    "ay": 1,
    "az": 2,
    "gx": 3,
    "gy": 4,
    "gz": 5,
    "roll": 6,
    "pitch": 7,
    "yaw": 8,
    "lat": 9,
    "lng": 10,
}

LONG_TERM_IDLE_TIMEOUT = 20
SHORT_TERM_IDLE_TIMEOUT = 4
IDLE_THRESHOLD = 0.1

SINGAL_INTENSITY_RANGE = [50, 100]
MAX_SIGNAL_FREQUENCY = 4  # Highest Frequency between pairs of signals In seconds
# SIGNAL_PERIOD = 1 / SIGNAL_FREQUENCY
MAX_SIGNAL_HALT = 0.8 # Longest Possible Time between signals In seconds


######### Obstacle Avoidance #########
NUM_CLASSES = 1
SEG_IMAGE_UNIFORM_THRES = 15.0
SEG_PR_MASK_MEAN_THRES = 0.07
# SEG_IMAGE_UNIFORM_THRES=0
# SEG_PR_MASK_MEAN_THRES=0
SEG_ALPHA = 0.5  # how much to weight the current seg mask over the previous one
SEG_TIME_INTERVAL = 0.

OBS_TURN_THRESHOLD = 13.5
OBS_DIST_TOO_CLOSE_SCREEN_RATIO = 0.15
OBS_HALT_QUICKEN_MULTIPLIER = 0.2
MAX_TURN_BUFFER = 5
MAX_OBSTACLE_BUFFER = 3

######### Object Detection #########
PATH_OBJECTS = ['stairs', 'person', 'chair',
                'escalator', 'traffic light', 'car']
COCO_CLASS = ['door', 'stairs', 'person',
              'chair', 'escalator', 'traffic light', 'car']
# COCO_CLASS= ['person', 'bicycle', 'car', 'motorcycle', 'airplane', 'bus', 'train', 'truck', 'boat', 'traffic light',
#         'fire hydrant', 'stop sign', 'parking meter', 'bench', 'bird', 'cat', 'dog', 'horse', 'sheep', 'cow',
#         'elephant', 'bear', 'zebra', 'giraffe', 'backpack', 'umbrella', 'handbag', 'tie', 'suitcase', 'frisbee',
#         'skis', 'snowboard', 'sports ball', 'kite', 'baseball bat', 'baseball glove', 'skateboard', 'surfboard',
#         'tennis racket', 'bottle', 'wine glass', 'cup', 'fork', 'knife', 'spoon', 'bowl', 'banana', 'apple',
#         'sandwich', 'orange', 'broccoli', 'carrot', 'hot dog', 'pizza', 'donut', 'cake', 'chair', 'couch',
#         'potted plant', 'bed', 'dining table', 'toilet', 'tv', 'laptop', 'mouse', 'remote', 'keyboard', 'cell phone',
#         'microwave', 'oven', 'toaster', 'sink', 'refrigerator', 'book', 'clock', 'vase', 'scissors', 'teddy bear',
#         'hair drier', 'toothbrush']
GOAL_OBJECTS = ['door', 'person']
CONF_THRESHOLD = 0.30
IOU_THRESHOLD = 0.45

######### Image Matching #########
# TEMPLATE_PATH = os.path.join('testdata', 'template_images', 'phone-inhouse')
IMAGE_MATCHING_CHANGING_THRESHOLD = 1
IMAGE_MATCHING_EXPLORATION_THRESHOLD = 10

# MAP_PATH = os.path.join('testdata', 'path_route.txt')
# WALK_PATH = os.path.join('testdata', 'path_walk.txt')

######### Cloud Models #########
MS_ENDPOINT = 'https://aiguided-ocr.cognitiveservices.azure.com/'
# in seconds
OBJ_DET_TIME_INTERVAL = 1
IMG_CAPTION_TIME_INTERVAL = 3
IMG_TAG_TIME_INTERVAL = 2
TEXT_TO_SPEECH_TIME_INTERVAL = 1

######### Connection to Main Server #########
MAIN_SERVER_HTTPS = True
MAIN_SERVER = 'https://api.ai-guided.com' if MAIN_SERVER_HTTPS else 'http://100.71.28.81:8007'
MAIN_SERVER_PORT = 443 if MAIN_SERVER_HTTPS else 8007

# in seconds
GARBAGE_CLEAR_INTERVAL = 60