
import os
from os.path import join
try:
    from onnxruntime import InferenceSession
except:
    pass
from .keypoints import KeyPoint

class KeyPointONNX(KeyPoint):
    def __init__(self,root,config_loader):
        KeyPoint.__init__(self,root,config_loader)
        if not self.enable:
            return
        # get class 
        assert os.path.exists(self.engine_file), "Weights file not found"
        assert self.engine_file.endswith('.onnx'), "file must be .onnx"
        self.engine = InferenceSession(self.engine_file, providers=['CPUExecutionProvider'])
    
    def infer(self):        
        semi,coarse_desc = self.engine.run(['semi','desc'], {"input": self.image})
        
        self.extract(semi, coarse_desc)

    def destroy(self):
        pass