
import numpy as np
import os
try:
    from onnxruntime import InferenceSession
except:
    pass
from algorithms.constants import COCO_CLASS,CONF_THRESHOLD,IOU_THRESHOLD
from .object_detection import ObjectDetection
from .nms import get_det_boxes

class ObjectDetectionONNX(ObjectDetection):
    def __init__(self,root,config_loader):
        ObjectDetection.__init__(self,root,config_loader)
        # get class 
        assert os.path.exists(self.engine_file), "Weights file not found"
        assert self.engine_file.endswith('.onnx'), "file must be .onnx"
        self.engine = InferenceSession(self.engine_file, providers=['CPUExecutionProvider'])
    
    def detect(self, image):        
        output = np.array(self.engine.run(['output'], {"images": image})[0])
        result = get_det_boxes(output,COCO_CLASS,CONF_THRESHOLD,IOU_THRESHOLD,max_det=10)
        return result
    
    def destroy(self):
        pass