import numpy as np

class Line:
    def __init__(self, *args):
        if len(args) > 0 and len(args[0]) == 4:
            self.valid = True
            self.x1 = int(args[0][0])
            self.y1 = int(args[0][1])
            self.x2 = int(args[0][2])
            self.y2 = int(args[0][3])
            self.slope = self.get_slope()
            self.angle = self.get_angle()
        else:
            self.valid = False

    def __repr__(self):
        return str('[(%d, %d), (%d, %d)]' % (self.x1, self.y1, self.x2, self.y2))
    
    def get_slope(self):
        if self.x2 == self.x1:
            return 999
        else:
            return (- (self.y2 - self.y1) / (self.x2 - self.x1))

    def get_angle(self):
        angle = (np.arctan2(self.y2 - self.y1, self.x2 - self.x1) * 180 / np.pi)
        if angle < 0:
            angle += 180
        angle -= 90
        angle *= -1
        return angle

    def get_line(self):
        return [(self.x1, self.y1), (self.x2, self.y2)]

    def update_coord(self, *args):
        if len(args) > 0 and len(args[0]) == 4:
            self.valid = True
            self.x1 = int(args[0][0])
            self.y1 = int(args[0][1])
            self.x2 = int(args[0][2])
            self.y2 = int(args[0][3])
            self.slope = self.get_slope()
            self.angle = self.get_angle()
        else:
            self.valid = False